import { AnyObject } from '@loopback/repository';
import { ILogger } from '@sourceloop/core';
import { CodeReaderFn, CodeWriterFn, JWTVerifierFn } from '../../../providers';
import { AuthClientRepository, OtpCacheRepository, UserCredentialsRepository, UserRepository } from '../../../repositories';
import { AuthTokenRequest, AuthUser, OtpLoginRequest, OtpSendRequest } from '../models';
import { CodeResponse, QrCodeCheckResponse, QrCodeCreateResponse } from '../types';
export declare class OtpController {
    authClientRepository: AuthClientRepository;
    userRepo: UserRepository;
    otpCacheRepo: OtpCacheRepository;
    userCredsRepository: UserCredentialsRepository;
    logger: ILogger;
    private readonly jwtVerifier;
    constructor(authClientRepository: AuthClientRepository, userRepo: UserRepository, otpCacheRepo: OtpCacheRepository, userCredsRepository: UserCredentialsRepository, logger: ILogger, jwtVerifier: JWTVerifierFn<AnyObject>);
    sendOtp(req: OtpSendRequest): Promise<void>;
    verifyOtp(req: OtpLoginRequest, user: AuthUser | undefined, codeWriter: CodeWriterFn): Promise<CodeResponse>;
    checkQr(code: string, clientId: string, codeReader: CodeReaderFn): Promise<QrCodeCheckResponse>;
    createQr(req: AuthTokenRequest, codeReader: CodeReaderFn): Promise<QrCodeCreateResponse>;
}
